package com.iden.bms.controller;

import com.iden.bms.service.SubdistrictService;
import com.iden.common.annotation.Permission;
import com.iden.common.exception.BDException;
import com.iden.common.util.PageResult;
import com.iden.common.util.Result;
import com.iden.common.util.WebPageUtils;
import com.iden.common.vo.SubdistrictVO;
import com.iden.common.vo.PageReqVO;
import com.iden.common.vo.UserLoginedConvertVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * @Author: lilt
 * @Date: 2021/5/26
 * @Desc:
 */
@RestController
@Api(value = "SubdistrictController", tags = { "区域管理" })
@Slf4j
@RequestMapping("/bms/subdistrict")
@Permission
public class SubistrictController {

    @Autowired
    private SubdistrictService subdistrictService;

    @GetMapping("/listSubdistrict4Select")
    @ApiOperation(value = "区域下拉列表 ")
    public Result<List<SubdistrictVO>> listSubdistrict4Select(HttpServletRequest request, @RequestHeader(value = "token") String token,
                                                   PageReqVO pageReqVo){
        try {
            UserLoginedConvertVO loginUser = WebPageUtils.getCurrentLoginedUser(request);
            List<SubdistrictVO> datas = this.subdistrictService.listSubdistrict4Select(loginUser);
            return Result.success(datas);
        }catch (BDException e) {
            log.error("区域下拉列表查询-分页列表出现异常",e);
            return  PageResult.error(e.getMessage());
        } catch (Exception e) {
            log.error("区域管理: 区域下拉列表查询出现异常",e);
            return PageResult.error( "获取列表失败");
        }
    }

}
