package com.iden.bms.controller;



import com.iden.bms.service.SysDictService;
import com.iden.common.util.Result;
import com.iden.common.vo.SysDictItemVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.List;


/**
 * @author
 * @version 1.0.0 创建于 2021-12-04
 **/
@Api(value = "SysDictController", tags = { "系统字典管理接口" })
@RestController
@Slf4j
@RequestMapping("/bms/sysdict")
public class SysDictController {

    @Resource
    private SysDictService sysDictService;


    @ApiOperation(value = "根据字典编码查询字典项全部列表")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "header", required = true, name = "token", dataType = "String", value = "token验证信息"),
            @ApiImplicitParam(name = "dictCode", value = "字典编码",
                    dataType = "String", paramType = "query",
                    required = true)
    })
    @GetMapping(value = "/queryDictItemsByCode", produces = "application/json;charset=utf-8")
    public Result<List<SysDictItemVO>> queryDictItemsByCode(
            HttpServletRequest request, @RequestHeader(value = "token") String token,
            @RequestParam(name = "dictCode", required = true) String dictCode
            ) {
        try {

            List<SysDictItemVO> list = this.sysDictService.queryDictItemsByCode(dictCode);
            return Result.success(list);
        } catch (Exception e) {
            e.printStackTrace();
            return Result.error( "获取列表失败");
        }
    }

}
