package com.iden.bms.service;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.iden.common.cache.DictCache;
import com.iden.common.entity.IdenSysDict;
import com.iden.common.entity.IdenSysDictItem;
import com.iden.common.service.IdenSysDictItemService;
import com.iden.common.service.IdenSysDictService;
import com.iden.common.vo.SysDictItemVO;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Author: stw
 * @Date: 2021/7/14
 * @Desc:
 */
@Service
public class SysDictService {
    @Resource
    private IdenSysDictService idenSysDictService;
    @Resource
    private IdenSysDictItemService idenSysDictItemService;

    /**
     * 根据typeCode查询编码列表
     * @return
     */
    public List<SysDictItemVO> queryDictItemsByCode(String dictCode){
        QueryWrapper<IdenSysDict>  queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(IdenSysDict::getCode,dictCode);
        IdenSysDict idenSysDict = idenSysDictService.getOne(queryWrapper);
        if (idenSysDict == null){
           return null;
        }
        List<SysDictItemVO> datas = new ArrayList<>();
        QueryWrapper<IdenSysDictItem>  queryWrapper1 = new QueryWrapper<>();
        queryWrapper1.lambda().eq(IdenSysDictItem::getDictId,idenSysDict.getId())
                .orderByAsc(IdenSysDictItem::getSort);
        List<IdenSysDictItem> list = this.idenSysDictItemService.list(queryWrapper1);
        if (list != null){
            list.forEach(item -> {
                SysDictItemVO vo = new SysDictItemVO();
                BeanUtil.copyProperties(item,vo);
                datas.add(vo);
            });
        }
        return datas;
    }

    /**
     * 初始化把字典放入内存缓存
     * @return
     */
    public void initDictCache (){

        List<IdenSysDict> idenSysDicts = idenSysDictService.list();
       if(CollUtil.isNotEmpty(idenSysDicts)){
           Map<String,  List<SysDictItemVO>> mqttDataConnectorMap = new HashMap<>();

           idenSysDicts.forEach(item ->{
               QueryWrapper<IdenSysDictItem>  queryWrapper1 = new QueryWrapper<>();
               queryWrapper1.lambda().eq(IdenSysDictItem::getDictId,item.getId())
                       .orderByAsc(IdenSysDictItem::getSort);
               List<IdenSysDictItem> list = this.idenSysDictItemService.list(queryWrapper1);
               if (list != null){
                   List<SysDictItemVO> datas = new ArrayList<>();
                   list.forEach(item1 -> {
                       SysDictItemVO vo = new SysDictItemVO();
                       BeanUtil.copyProperties(item1,vo);
                       datas.add(vo);
                   });
                   mqttDataConnectorMap.put(item.getCode(),datas);
               }
           });
           DictCache.setListSysDictItemVOMap(mqttDataConnectorMap);
       }

    }

}
